USRP Hardware Driver and USRP Manual: uhd::usrp::cal::zbx_rx_dsa_cal Class Reference

| USRP Hardware Driver and USRP Manual Version: 4.9.0.makepkg-0-g9ec1f582 UHD and USRP Manual |

Loading...
Searching...
No Matches
uhd::usrp::cal::zbx_rx_dsa_cal Class Referenceabstract

`#include <uhd/cal/dsa_cal.hpp>`

Inheritance diagram for uhd::usrp::cal::zbx_rx_dsa_cal:

## Public Types
using | sptr = std::shared_ptr<zbx_rx_dsa_cal>
using | step_settings = std::array<uint32_t, NUM_DSA>

## Public Member Functions
virtual void | add_frequency_band (const double max_freq, const std::string &name, std::array< step_settings, NUM_GAIN_STAGES > dsa_steps)=0
virtual bool | is_same_band (double freq1, double freq2) const =0
virtual const step_settings | get_dsa_setting (const double freq, const size_t gain_index) const =0
virtual std::vector< uint32_t > | get_band_settings (double freq, uint8_t dsa) const =0
virtual void | clear ()=0
Public Member Functions inherited from uhd::usrp::cal::container
virtual | ~container ()=default
virtual std::string | get_name () const =0
| Return the name of this calibration table.
virtual std::string | get_serial () const =0
| Return the device serial of this calibration table.
virtual uint64_t | get_timestamp () const =0
| Timestamp of acquisition time.
virtual std::vector< uint8_t > | serialize ()=0
| Return a serialized version of this container.
virtual void | deserialize (const std::vector< uint8_t > &data)=0
| Populate this class from the serialized data.

## Static Public Member Functions
static sptr | make (const std::string &name, const std::string &serial, const uint64_t timestamp)
| Factory for new cal data sets.
static sptr | make ()
| Default factory.
Static Public Member Functions inherited from uhd::usrp::cal::container
template<typename container_type>
static std::shared_ptr< container_type > | make (const std::vector< uint8_t > &data)
| Generic factory for cal data from serialized data.

## Static Public Attributes
static constexpr uint32_t | NUM_DSA = 4
static constexpr uint32_t | NUM_GAIN_STAGES = 61

## Detailed Description

Class that stores DSA indices for all ZBX TX bands.

## Member Typedef Documentation

## ◆ sptr

using uhd::usrp::cal::zbx_rx_dsa_cal::sptr = std::shared_ptr<zbx_rx_dsa_cal>

## ◆ step_settings

using uhd::usrp::cal::zbx_rx_dsa_cal::step_settings = std::array<uint32_t, NUM_DSA>

## Member Function Documentation

## ◆ add_frequency_band()

virtual void uhd::usrp::cal::zbx_rx_dsa_cal::add_frequency_band | ( | const double | max_freq,
|  | const std::string & | name,
|  | std::array< step_settings, NUM_GAIN_STAGES > | dsa_steps )
| pure virtual

Add a new band description.

max_freq is the (inclusive) upper limit for the band (lower limit derives from the other bands). Name is an text representation (human readable) for the band. dsa_steps is an array of DSA settings for all gains in the band.

## ◆ clear()

virtual void uhd::usrp::cal::zbx_rx_dsa_cal::clear | ( |  | ) |
| pure virtual

Clear all stored values

## ◆ get_band_settings()

virtual std::vector< uint32_t > uhd::usrp::cal::zbx_rx_dsa_cal::get_band_settings | ( | double | freq,
|  | uint8_t | dsa ) const
| pure virtual

Retrieves DSA settings as flat list. The values are flattend by frequency band, gain and values in that order. Use NUM_DSA and NUM_GAIN_STAGES to find values in the list.

## ◆ get_dsa_setting()

virtual const step_settings uhd::usrp::cal::zbx_rx_dsa_cal::get_dsa_setting | ( | const double | freq,
|  | const size_t | gain_index ) const
| pure virtual

Retrieves DSA settings for frequency and gain_index.

The settings are retrieved from the band with the biggest max_freq that is smaller or equal to freq. DSA settings are the settings at gain_index in that band. Value errors are thrown if freq is larger that the largest freq_max of all bands or gain_index is not within range.

## ◆ is_same_band()

virtual bool uhd::usrp::cal::zbx_rx_dsa_cal::is_same_band | ( | double | freq1,
|  | double | freq2 ) const
| pure virtual

## ◆ make() [1/2]

sptr uhd::usrp::cal::zbx_rx_dsa_cal::make | ( |  | ) |
| static

Default factory.

## ◆ make() [2/2]

sptr uhd::usrp::cal::zbx_rx_dsa_cal::make | ( | const std::string & | name,
|  | const std::string & | serial,
|  | const uint64_t | timestamp )
| static

Factory for new cal data sets.

## Member Data Documentation

## ◆ NUM_DSA

uint32_t uhd::usrp::cal::zbx_rx_dsa_cal::NUM_DSA = 4
| staticconstexpr

## ◆ NUM_GAIN_STAGES

uint32_t uhd::usrp::cal::zbx_rx_dsa_cal::NUM_GAIN_STAGES = 61
| staticconstexpr

The documentation for this class was generated from the following file:

- dsa_cal.hpp